diff --git a/src/include/pg_config.h.in b/src/include/pg_config.h.in
index 661c4a9b168..661c12e9bf3 100644
--- a/src/include/pg_config.h.in
+++ b/src/include/pg_config.h.in
@@ -85,6 +85,14 @@
    don't. */
 #undef HAVE_DECL_F_FULLFSYNC
 
+/* Define to 1 if you have the declaration of `MADV_POPULATE_WRITE', and to 0
+   if you don't. */
+#undef HAVE_DECL_MADV_POPULATE_WRITE
+
+/* Define to 1 if you have the declaration of `MADV_REMOVE', and to 0 if you
+   don't. */
+#undef HAVE_DECL_MADV_REMOVE
+
 /* Define to 1 if you have the declaration of `memset_s', and to 0 if you
    don't. */
 #undef HAVE_DECL_MEMSET_S
diff --git a/src/include/pg_config_manual.h b/src/include/pg_config_manual.h
index 521b49b8888..ab944babe2b 100644
--- a/src/include/pg_config_manual.h
+++ b/src/include/pg_config_manual.h
@@ -131,6 +131,20 @@
 #define EXEC_BACKEND
 #endif
 
+/*
+ * HAVE_RESIZABLE_SHMEM indicates whether resizable shared memory structures are
+ * supported. The implementation requires Linux-specific madvise constants
+ * (MADV_REMOVE and MADV_POPULATE_WRITE) and existence of mprotect() API.
+ *
+ * TODO: We may want to remove EXEC_BACKEND from the condition to test attaching
+ * and resizing resizable shared memory structures in EXEC_BACKEND mode. Windows
+ * will anyway won't have HAVE_RESIZABLE_SHMEM defined since it won't have
+ * MADV_REMOVE and MADV_POPULATE_WRITE.
+ */
+#if HAVE_DECL_MADV_REMOVE && HAVE_DECL_MADV_POPULATE_WRITE && !defined(EXEC_BACKEND)
+#define HAVE_RESIZABLE_SHMEM
+#endif
+
 /*
  * USE_POSIX_FADVISE controls whether Postgres will attempt to use the
  * posix_fadvise() kernel call.  Usually the automatic configure tests are
diff --git a/src/include/storage/ipc.h b/src/include/storage/ipc.h
index b205b00e7a1..46ae87fe863 100644
--- a/src/include/storage/ipc.h
+++ b/src/include/storage/ipc.h
@@ -78,7 +78,7 @@ extern void check_on_shmem_exit_lists_are_empty(void);
 extern PGDLLIMPORT shmem_startup_hook_type shmem_startup_hook;
 
 extern void RegisterBuiltinShmemCallbacks(void);
-extern Size CalculateShmemSize(void);
+extern void CalculateShmemSize(size_t *initial, size_t *min, size_t *max);
 extern void CreateSharedMemoryAndSemaphores(void);
 #ifdef EXEC_BACKEND
 extern void AttachSharedMemoryStructs(void);
diff --git a/src/include/storage/pg_shmem.h b/src/include/storage/pg_shmem.h
index 10c7b065861..50474c2d579 100644
--- a/src/include/storage/pg_shmem.h
+++ b/src/include/storage/pg_shmem.h
@@ -85,10 +85,14 @@ extern void PGSharedMemoryReAttach(void);
 extern void PGSharedMemoryNoReAttach(void);
 #endif
 
-extern PGShmemHeader *PGSharedMemoryCreate(Size size,
+extern PGShmemHeader *PGSharedMemoryCreate(Size initial_size, Size max_size,
 										   PGShmemHeader **shim);
 extern bool PGSharedMemoryIsInUse(unsigned long id1, unsigned long id2);
 extern void PGSharedMemoryDetach(void);
+extern bool PGSharedMemoryEnsureFreed(void *addr, Size size);
+extern bool PGSharedMemoryEnsureAllocated(void *addr, Size size);
+extern bool PGSharedMemoryProtect(void *rw_start, void *rw_end, void *prot_end);
 extern void GetHugePageSize(Size *hugepagesize, int *mmap_flags);
+extern size_t GetOSPageSize(void);
 
 #endif							/* PG_SHMEM_H */
diff --git a/src/include/storage/shmem.h b/src/include/storage/shmem.h
index 43b636868c7..947debcede4 100644
--- a/src/include/storage/shmem.h
+++ b/src/include/storage/shmem.h
@@ -57,6 +57,22 @@ typedef struct ShmemStructOpts
 	 */
 	size_t		alignment;
 
+	/*
+	 * Minimum size this structure can shrink to. Should be set to 0 for
+	 * fixed-size structures.
+	 */
+	ssize_t		minimum_size;
+
+	/*
+	 * Maximum size this structure can grow upto in future. The memory is not
+	 * allocated right away but the corresponding address space is reserved so
+	 * that memory can be mapped to it when the structure grows. Typically
+	 * should be used for large resizable structures which need several pages
+	 * worth of contiguous memory. Should be set to 0 for fixed-size
+	 * structures.
+	 */
+	ssize_t		maximum_size;
+
 	/*
 	 * When the shmem area is initialized or attached to, pointer to it is
 	 * stored in *ptr.  It usually points to a global variable, used to access
@@ -168,6 +184,9 @@ typedef struct ShmemCallbacks
 
 extern void RegisterShmemCallbacks(const ShmemCallbacks *callbacks);
 extern bool ShmemAddrIsValid(const void *addr);
+extern bool ShmemResizeStruct(const char *name, Size new_size);
+extern void ShmemProtectStruct(const char *name);
+extern void ShmemReprotectResizableStructs(void);
 
 /*
  * These macros provide syntactic sugar for calling the underlying functions
diff --git a/src/include/storage/shmem_internal.h b/src/include/storage/shmem_internal.h
index 8746b614fa3..6c8c81812a8 100644
--- a/src/include/storage/shmem_internal.h
+++ b/src/include/storage/shmem_internal.h
@@ -36,7 +36,7 @@ extern void ResetShmemAllocator(void);
 
 extern void ShmemRequestInternal(ShmemStructOpts *options, ShmemRequestKind kind);
 
-extern size_t ShmemGetRequestedSize(void);
+extern void ShmemGetRequestedSize(size_t *initial, size_t *min, size_t *max);
 extern void ShmemInitRequested(void);
 #ifdef EXEC_BACKEND
 extern void ShmemAttachRequested(void);
diff --git a/src/test/modules/test_shmem/meson.build b/src/test/modules/test_shmem/meson.build
index fb4bf328b8f..1f795aae7eb 100644
--- a/src/test/modules/test_shmem/meson.build
+++ b/src/test/modules/test_shmem/meson.build
@@ -27,7 +27,8 @@ tests += {
   'bd': meson.current_build_dir(),
   'tap': {
     'tests': [
-      't/001_late_shmem_alloc.pl',
+      't/001_fixed_shmem_struct.pl',
+      't/002_resizable_shmem_struct.pl',
     ],
   },
 }
diff --git a/src/test/modules/test_shmem/t/001_late_shmem_alloc.pl b/src/test/modules/test_shmem/t/001_fixed_shmem_struct.pl
similarity index 58%
rename from src/test/modules/test_shmem/t/001_late_shmem_alloc.pl
rename to src/test/modules/test_shmem/t/001_fixed_shmem_struct.pl
index 5cf07d071ec..d231821e0b4 100644
--- a/src/test/modules/test_shmem/t/001_late_shmem_alloc.pl
+++ b/src/test/modules/test_shmem/t/001_fixed_shmem_struct.pl
@@ -56,5 +56,36 @@ else
 	);
 }
 
+###
+# Test that a fixed-size shared memory structure cannot be resized.
+# Only relevant on platforms that support resizable shmem.
+###
+my $have_resizable_shmem =
+  $node->safe_psql('postgres', 'SHOW have_resizable_shmem;') eq 'on';
+
+if ($have_resizable_shmem)
+{
+   # Try expanding the fixed-size structure
+   my ($ret, $stdout, $stderr) =
+     $node->psql("postgres", "SELECT test_shmem_resize_fixed(1000);");
+   isnt($ret, 0, "expanding a fixed-size structure fails");
+   like($stderr, qr/is not resizable/, "expand error message mentions not resizable");
+
+   # Try shrinking the fixed-size structure
+   ($ret, $stdout, $stderr) =
+     $node->psql("postgres", "SELECT test_shmem_resize_fixed(1);");
+   isnt($ret, 0, "shrinking a fixed-size structure fails");
+   like($stderr, qr/is not resizable/, "shrink error message mentions not resizable");
+}
+
+###
+# Test that minimum_size and maximum_size equal size for a fixed-size structure
+# in pg_shmem_allocations.
+###
+is($node->safe_psql('postgres',
+   "SELECT minimum_size = size AND maximum_size = size FROM pg_shmem_allocations WHERE name = 'test_shmem area';"),
+   't', "fixed-size structure has minimum_size = maximum_size = size");
+
 $node->stop;
+
 done_testing();
diff --git a/src/test/modules/test_shmem/t/002_resizable_shmem_struct.pl b/src/test/modules/test_shmem/t/002_resizable_shmem_struct.pl
new file mode 100644
index 00000000000..4d2fd3c4282
--- /dev/null
+++ b/src/test/modules/test_shmem/t/002_resizable_shmem_struct.pl
@@ -0,0 +1,382 @@
+# Copyright (c) 2025-2026, PostgreSQL Global Development Group
+
+use strict;
+use warnings FATAL => 'all';
+
+use PostgreSQL::Test::Cluster;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+# Test resizable shared memory functionality, both when loaded at startup via
+# shared_preload_libraries and when loaded after startup (late allocation).
+
+# Verify that enough shared memory is allocated to cover the resizable_shmem
+# structure at its current size but does not exceed the memory required by the
+# current sizes of all shared memory structures. We expect that the backend
+# where we run the query will have touched the entire resizable_shmem structure,
+# so that all the memory pages covering the resizable structure are mapped to
+# the backend's address space.
+#
+# Since we have configured the server so that resizable shared struture
+# dominates the main shared memory segment, the total memory allocated to other
+# shared memory structures does not result in false positive tests below.
+sub check_shmem_usage
+{
+	my ($session, $label, $node) = @_;
+
+	my $shmem_usage = $session->query_safe('SELECT test_shmem_usage();', verbose => 0);
+	my $total_alloc = $node->safe_psql('postgres', "SELECT sum(allocated_size) FROM pg_shmem_allocations;");
+	my $resizable_alloc = $node->safe_psql('postgres',
+											"SELECT allocated_size FROM pg_shmem_allocations WHERE name = 'resizable_shmem';");
+
+	diag "$label: shmem_usage=$shmem_usage, resizable_shmem allocated=$resizable_alloc, sum(allocated_size)=$total_alloc";
+	ok($shmem_usage <= $total_alloc,
+	   "$label: allocated shared memory does not exceed total allocated size");
+	ok($shmem_usage >= $resizable_alloc,
+	   "$label: shared memory usage covers the resizable_shmem allocation");
+}
+
+# Test a resize operation: resize, verify old data, write new data, verify
+# new data, and check shmem usage.  Returns updated ($num_entries, $value).
+sub test_resize
+{
+	my ($node, $prefix, $old_num_entries, $old_value, $new_num_entries, $new_value, $label) = @_;
+
+	$label = "$prefix: $label";
+
+	my $session1 = $node->background_psql('postgres');
+	my $session2 = $node->background_psql('postgres');
+
+	$session1->query_safe("SELECT resizable_shmem_resize($new_num_entries);",
+						  verbose => 0);
+
+	# Old data should still be intact in the (possibly smaller) area
+	my $readable_entries = ($new_num_entries < $old_num_entries) ? $new_num_entries : $old_num_entries;
+	is($session1->query_safe("SELECT resizable_shmem_read($readable_entries, $old_value);",
+							 verbose => 0),
+	   't', "old data readable after $label");
+
+	$session2->query_safe("SELECT resizable_shmem_write($new_value);",
+						  verbose => 0);
+	is($session1->query_safe("SELECT resizable_shmem_read($new_num_entries, $new_value);",
+							 verbose => 0),
+	   't', "new data readable after $label");
+
+	check_shmem_usage($session1, "$label (session 1)", $node);
+	check_shmem_usage($session2, "$label (session 2)", $node);
+
+	$session1->quit;
+	$session2->quit;
+
+	return ($new_num_entries, $new_value);
+}
+
+# Verify that reads or writes past the current size, but within the reserved
+# maximum, fault when they reach the protected region.
+sub test_fault_beyond_size
+{
+	my ($node, $initial_entries, $prefix) = @_;
+
+	# Enable restart_after_crash to test postmaster driven restart with
+	# resizable shared memory.
+	$node->safe_psql('postgres',
+		'ALTER SYSTEM SET restart_after_crash = on;');
+	$node->reload;
+
+	for my $mode ('write', 'read')
+	{
+		my ($ret, $stdout, $stderr) = $node->psql('postgres',
+			"SELECT resizable_shmem_access_beyond_size('$mode');");
+		ok($ret != 0, "$prefix: $mode past current size crashes the backend");
+		like($stderr,
+			 qr/server closed the connection unexpectedly|connection to server was lost/,
+			 "$prefix: $mode crash reports lost connection");
+
+		$node->poll_query_until('postgres', 'SELECT 1', '1')
+		  or die "server did not come back after $mode crash";
+	}
+
+	is($node->safe_psql('postgres',
+			"SELECT resizable_shmem_read($initial_entries, 0);"),
+	   't', "$prefix: read succeeds after crash recovery");
+
+	$node->safe_psql('postgres', 'ALTER SYSTEM RESET restart_after_crash;');
+	$node->reload;
+}
+
+# Run the full suite of resizable shared memory tests on the given node.
+sub run_resizable_tests
+{
+	my ($node, $initial_entries, $max_entries, $prefix) = @_;
+	my $have_resizable_shmem = $node->safe_psql('postgres', 'SHOW have_resizable_shmem;') eq 'on';
+
+	my $num_entries = $initial_entries;
+
+	# Basic read/write should work on all platforms
+	my $value = 100;
+	$node->safe_psql('postgres', "SELECT resizable_shmem_write($value);");
+	is($node->safe_psql('postgres', "SELECT resizable_shmem_read($num_entries, $value);"),
+	   't', "$prefix: data read after write successful");
+
+	if ($have_resizable_shmem)
+	{
+		# Initial structure state
+		my $session1 = $node->background_psql('postgres');
+		my $session2 = $node->background_psql('postgres');
+
+		$value = 100;
+		# Write and read the initial set of entries.
+		$session1->query_safe("SELECT resizable_shmem_write($value);", verbose => 0);
+		is($session2->query_safe("SELECT resizable_shmem_read($num_entries, $value);",
+								 verbose => 0),
+		   't', "$prefix: data read after write successful");
+		check_shmem_usage($session1, "$prefix: initial write (session 1)", $node);
+		check_shmem_usage($session2, "$prefix: initial write (session 2)", $node);
+		$session1->quit;
+		$session2->quit;
+
+		# Verify no other structure is resizable
+		is($node->safe_psql('postgres', "SELECT count(*) FROM pg_shmem_allocations WHERE name <> 'resizable_shmem' AND maximum_size <> minimum_size;"),
+							'0', "$prefix: no other resizable structures");
+
+		# Resize to maximum
+		($num_entries, $value) = test_resize($node, $prefix, $num_entries, $value,
+											 $max_entries, 500, 'resize to maximum');
+
+		# Shrink to 75% of max
+		my $shrink_entries = int($max_entries * 3 / 4);
+		($num_entries, $value) = test_resize($node, $prefix, $num_entries, $value,
+											 $shrink_entries, 999, 'shrinking');
+
+		# Resize to the same size (no-op)
+		($num_entries, $value) = test_resize($node, $prefix, $num_entries, $value,
+											 $num_entries, 1999, 'no-op resize');
+
+		# Shrink to minimum i.e. zero entries and grow back
+		($num_entries, $value) = test_resize($node, $prefix, $num_entries, $value,
+											 0, 0, 'shrink to minimum');
+		($num_entries, $value) = test_resize($node, $prefix, $num_entries, $value,
+											 $initial_entries, 2999,
+											 'grow back from minimum');
+
+		# Test resize failure (attempt to resize beyond max - should fail)
+		my ($ret, $stdout, $stderr) =
+			$node->psql('postgres', "SELECT resizable_shmem_resize(" . ($max_entries * 2) . ");");
+		ok($ret != 0 || $stderr =~ /ERROR/, "$prefix: Resize beyond maximum fails");
+
+		# Resize to a size below minimum_size must fail.
+		($ret, $stdout, $stderr) =
+			$node->psql('postgres', 'SELECT resizable_shmem_resize(-1);');
+		ok($ret != 0, "$prefix: resize below minimum_size fails");
+		like($stderr,
+			 qr/cannot shrink shared memory structure "resizable_shmem" below minimum size/,
+			 "$prefix: resize-below-minimum error comes from ShmemResizeStruct");
+
+		# The fault test relies on a hole being present between the current end
+		# of the structure and its maximal end. Skip when the structure does not
+		# span multiple pages.
+		my $spans_pages = $node->safe_psql('postgres', qq{
+			SELECT (maximum_size - minimum_size) >= test_shmem_pagesize()
+			FROM pg_shmem_allocations WHERE name = 'resizable_shmem';
+		});
+		if ($spans_pages ne 't')
+		{
+			diag "$prefix: skipping fault-beyond-size test: resizable_shmem does not span multiple shmem pages";
+		}
+		else
+		{
+			test_fault_beyond_size($node, $initial_entries, $prefix);
+		}
+	}
+	else
+	{
+		# On unsupported platforms, resizing should fail with a clear error
+		my ($ret, $stdout, $stderr) =
+			$node->psql('postgres', "SELECT resizable_shmem_resize($num_entries);");
+		ok($ret != 0, "$prefix: resize fails on unsupported platform");
+		like($stderr, qr/not supported/, "$prefix: resize error mentions not supported");
+	}
+}
+
+# Check the runtime-computed shared_memory_{initial,minimum,maximum}_size GUC
+# invariants.  min <= initial <= max must always hold.  When a resizable
+# structure has been registered on a server that supports resizable shared
+# memory structures, min must additionally be strictly less than max;
+# otherwise all three GUCs must be equal.
+sub check_shmem_size_gucs
+{
+	my ($node, $label) = @_;
+	my $pgdata = $node->data_dir;
+
+	my $get = sub {
+		my ($guc) = @_;
+		my ($stdout, $stderr) = run_command([ 'postgres', '-D' => $pgdata, '-C' => $guc ]);
+
+		return $stdout;
+	};
+
+	my $have_resizable_shmem = $get->('have_resizable_shmem');
+	my $ini = 0 + $get->('shared_memory_initial_size');
+	my $min = 0 + $get->('shared_memory_minimum_size');
+	my $max = 0 + $get->('shared_memory_maximum_size');
+	my $have_resizable_struct = ($get->('resizable_shmem.max_entries') ne '');
+
+	ok($min <= $ini && $ini <= $max, "$label: shared_memory size GUCs in expected order");
+
+	if ($have_resizable_struct && $have_resizable_shmem eq 'on')
+	{
+		ok($min < $max, "$label: min < max with resizable structures");
+	}
+	else
+	{
+		ok($min == $ini && $ini == $max,
+		   "$label: all shared_memory size GUCs equal when no resizable structures");
+	}
+}
+
+# Log the runtime shared_memory_{initial,minimum,maximum}_size GUCs and huge
+# pages usage information for easier debugging.
+sub diag_shmem_sizes
+{
+	my ($node, $label) = @_;
+
+	my $vals = $node->safe_psql('postgres', q{
+		SELECT format('initial=%s minimum=%s maximum=%s huge_pages_status=%s huge_page_size=%s shmem_page_size=%s',
+					  current_setting('shared_memory_initial_size'),
+					  current_setting('shared_memory_minimum_size'),
+					  current_setting('shared_memory_maximum_size'),
+					  current_setting('huge_pages_status'),
+					  current_setting('huge_page_size'),
+					  test_shmem_pagesize());
+	});
+	diag "$label: $vals";
+}
+
+### Set up a test node.
+#
+# Configure minimal shared memory so that the resizable_shmem structure dominates
+# and any unexpected increase is easy to detect.
+#
+# If we turn on huge pages and the machine where the test is running does not
+# have huge pages available, the test will fail midway because it will not be
+# able to allocate memory pages when expanding the resizable_shmem structure.
+# Hence we turn off huge pages for this test. The test outputs the GUCs
+# shared_memory_{initial,minimum,maximum}_size and information about huge pages.
+# By provisioning enough huge pages, and by changing huge_pages = try/on, the
+# test can be run with huge pages enabled.
+###
+my $node = PostgreSQL::Test::Cluster->new('resizable_shmem');
+$node->init;
+
+$node->append_conf('postgresql.conf', 'huge_pages = off');
+$node->append_conf('postgresql.conf', 'shared_buffers = 128kB');
+$node->append_conf('postgresql.conf', 'max_connections = 5');
+$node->append_conf('postgresql.conf', 'max_worker_processes = 0');
+$node->append_conf('postgresql.conf', 'max_wal_senders = 0');
+$node->append_conf('postgresql.conf', 'max_prepared_transactions = 0');
+$node->append_conf('postgresql.conf', 'max_locks_per_transaction = 10');
+$node->append_conf('postgresql.conf', 'max_pred_locks_per_transaction = 10');
+$node->append_conf('postgresql.conf', 'wal_buffers = 32kB');
+
+###
+# Test 1: Startup allocation via shared_preload_libraries
+###
+my $startup_initial = 25 * 1024 * 1024;
+my $startup_max = 100 * 1024 * 1024;
+
+$node->append_conf('postgresql.conf', 'shared_preload_libraries = test_shmem');
+$node->append_conf('postgresql.conf', "resizable_shmem.initial_entries = $startup_initial");
+$node->append_conf('postgresql.conf', "resizable_shmem.max_entries = $startup_max");
+
+check_shmem_size_gucs($node, 'startup preload');
+
+$node->start;
+$node->safe_psql('postgres', 'CREATE EXTENSION test_shmem;');
+diag_shmem_sizes($node, 'startup');
+run_resizable_tests($node, $startup_initial, $startup_max, 'startup');
+
+my $have_resizable_shmem = $node->safe_psql('postgres', 'SHOW have_resizable_shmem;') eq 'on';
+
+###
+# Test 2: Late allocation (loaded after startup, not in shared_preload_libraries).
+# Use much smaller sizes since only ~100KB of shared memory is available for
+# structures allocated after startup.
+###
+my $late_initial = 5 * 1024;
+my $late_max = 12 * 1024;
+
+$node->safe_psql('postgres', qq{
+	ALTER SYSTEM RESET shared_preload_libraries;
+	ALTER SYSTEM SET resizable_shmem.initial_entries = $late_initial;
+	ALTER SYSTEM SET resizable_shmem.max_entries = $late_max;
+});
+$node->safe_psql('postgres', 'DROP EXTENSION test_shmem;');
+$node->restart;
+
+$node->safe_psql('postgres', 'CREATE EXTENSION test_shmem;');
+diag_shmem_sizes($node, 'late');
+run_resizable_tests($node, $late_initial, $late_max, 'late');
+
+###
+# Test sysv shared memory does not support resizable shmem.  Only relevant on
+# platforms that support resizable shmem (HAVE_RESIZABLE_SHMEM), since the
+# module only sets maximum_size in that case.
+###
+if ($have_resizable_shmem)
+{
+	###
+	# Test 3: Verify that CREATE EXTENSION fails with sysv shared memory
+	# when loaded after startup (not in shared_preload_libraries).
+	###
+	$node->safe_psql('postgres', 'DROP EXTENSION test_shmem;');
+
+	# Remove settings that would cause the library to auto-load at startup:
+	# shared_preload_libraries and module-prefixed GUCs.  ALTER SYSTEM RESET
+	# only affects postgresql.auto.conf, so we must use adjust_conf to remove
+	# from postgresql.conf.
+	$node->adjust_conf('postgresql.conf', 'shared_preload_libraries', undef);
+	$node->adjust_conf('postgresql.conf', 'resizable_shmem.initial_entries', undef);
+	$node->adjust_conf('postgresql.conf', 'resizable_shmem.max_entries', undef);
+	$node->adjust_conf('postgresql.auto.conf', 'shared_preload_libraries', undef);
+	$node->adjust_conf('postgresql.auto.conf', 'resizable_shmem.initial_entries', undef);
+	$node->adjust_conf('postgresql.auto.conf', 'resizable_shmem.max_entries', undef);
+	$node->safe_psql('postgres', qq{
+		ALTER SYSTEM SET shared_memory_type = 'sysv';
+	});
+
+	$node->stop;
+
+	check_shmem_size_gucs($node, 'sysv');
+
+	$node->start;
+
+	is($node->safe_psql('postgres', 'SHOW have_resizable_shmem;'),
+	   'off',
+	   'have_resizable_shmem reports off with shared_memory_type = sysv');
+
+	my ($ret, $stdout, $stderr) =
+		$node->psql('postgres', 'CREATE EXTENSION test_shmem;');
+	ok($ret != 0, 'CREATE EXTENSION fails with resizable shmem on sysv');
+	like($stderr, qr/resizable shared memory requires shared_memory_type = mmap/,
+		'CREATE EXTENSION error mentions shared_memory_type = mmap requirement');
+
+	###
+	# Test 4: Verify that resizable structures are also rejected with sysv
+	# shared memory when loaded at startup via shared_preload_libraries.
+	###
+	$node->safe_psql('postgres', qq{
+		ALTER SYSTEM SET shared_preload_libraries = 'test_shmem';
+		ALTER SYSTEM SET resizable_shmem.initial_entries = $startup_initial;
+		ALTER SYSTEM SET resizable_shmem.max_entries = $startup_max;
+	});
+	$node->stop;
+
+	ok(!$node->start(fail_ok => 1),
+		'server fails to start with resizable shmem on sysv');
+
+	my $log = slurp_file($node->logfile);
+	like($log, qr/resizable shared memory requires shared_memory_type = mmap/,
+		'log mentions shared_memory_type = mmap requirement');
+}
+
+done_testing();
diff --git a/src/test/modules/test_shmem/test_shmem--1.0.sql b/src/test/modules/test_shmem/test_shmem--1.0.sql
index 2d01fd9256c..eb695604b1d 100644
--- a/src/test/modules/test_shmem/test_shmem--1.0.sql
+++ b/src/test/modules/test_shmem/test_shmem--1.0.sql
@@ -4,6 +4,61 @@
 \echo Use "CREATE EXTENSION test_shmem" to load this file. \quit
 
 
+-- ===================================================================
+-- Fixed-size shared memory structure
+-- ===================================================================
+
 CREATE FUNCTION get_test_shmem_attach_count()
 RETURNS pg_catalog.int4 STRICT
 AS 'MODULE_PATHNAME' LANGUAGE C;
+
+CREATE FUNCTION test_shmem_resize_fixed(pg_catalog.int4)
+RETURNS pg_catalog.void STRICT
+AS 'MODULE_PATHNAME' LANGUAGE C;
+
+
+-- ===================================================================
+-- Resizable shared memory structure
+-- ===================================================================
+
+-- Function to resize the test structure in the shared memory
+CREATE FUNCTION resizable_shmem_resize(new_entries integer)
+RETURNS bool
+AS 'MODULE_PATHNAME'
+LANGUAGE C STRICT;
+
+-- Function to write data to all entries in the test structure in shared memory
+-- Writing all the entries makes sure that the memory is actually allocated and
+-- mapped to the process, so that we can later measure the memory usage.
+CREATE FUNCTION resizable_shmem_write(entry_value integer)
+RETURNS void
+AS 'MODULE_PATHNAME'
+LANGUAGE C STRICT;
+
+-- Function to verify that specified number of initial entries have expected value.
+-- Reading all the entries makes sure that the memory is actually mapped to the
+-- process, so that we can later measure the memory usage.
+CREATE FUNCTION resizable_shmem_read(entry_count integer, entry_value integer)
+RETURNS boolean
+AS 'MODULE_PATHNAME'
+LANGUAGE C STRICT;
+
+-- Function to report memory mapped against the main shared memory segment in
+-- the backend where this function runs.
+CREATE FUNCTION test_shmem_usage()
+RETURNS bigint
+AS 'MODULE_PATHNAME'
+LANGUAGE C STRICT;
+
+-- Function to get the shared memory page size
+CREATE FUNCTION test_shmem_pagesize()
+RETURNS integer
+AS 'MODULE_PATHNAME'
+LANGUAGE C STRICT;
+
+-- Function to crash the backend by walking entries past the current size up to
+-- the reserved maximum, reading or writing each one as decided by mode.
+CREATE FUNCTION resizable_shmem_access_beyond_size(mode text)
+RETURNS integer
+AS 'MODULE_PATHNAME'
+LANGUAGE C STRICT;
